<template>
  <div class="row striped to-stripe mt-4">
    <div class="col-1">
      <div v-if="!newsEntry.imageId || newsEntry.imageId === ''">
        <font-awesome-icon
          :icon="['fas', 'exclamation-triangle']"
          class="font-x-large text-danger"
        ></font-awesome-icon>
      </div>
      <div v-else class="aspect-box overflow-hidden">
        <div class="aspect-container">
          <img
            :src="
              baseUrl + '/media/image/' + newsEntry.imageId + '?maxWidth=150'
            "
            class="w-100"
          />
        </div>
      </div>
    </div>
    <div class="col">
      <div class="font-weight-bold">{{ newsEntry.titleInternal }}</div>

      <div>
        <span v-for="lang in languages" :key="lang">
          <span
            v-if="!newsEntry.title[lang] || newsEntry.title[lang] === ''"
            class="mr-2"
          >
            <font-awesome-icon
              :icon="['fas', 'exclamation-triangle']"
              :class="{
                'text-warning': fallbackLanguage !== lang,
                'text-danger': fallbackLanguage === lang,
              }"
              class="mr-1"
            ></font-awesome-icon
            >{{ lang }}
          </span>
        </span>
      </div>
    </div>
    <div class="col">
      Date: {{ formatDateShort(newsEntry.dateDisplay) }}
      <font-awesome-icon
        v-if="!newsEntry.dateDisplay || newsEntry.dateDisplay === ''"
        :icon="['fas', 'exclamation-triangle']"
        class="text-danger"
      ></font-awesome-icon>
    </div>

    <div class="col">
      <div v-if="!newsEntry.linkTo || newsEntry.linkTo === ''">
        <font-awesome-icon
          :icon="['fas', 'exclamation-triangle']"
          class="text-danger"
        ></font-awesome-icon>
      </div>
      <a v-else :href="newsEntry.linkTo" target="_blank"
        >{{ newsEntry.linkTo }}
        <font-awesome-icon :icon="['fas', 'external-link-alt']"
      /></a>
    </div>

    <div class="col-2 pt-1 pb-1 text-nowrap text-right">
      <b-button
        v-if="!newsEntry.published && canPublish"
        @click="onPublish(newsEntry)"
        :disabled="!isPublishable"
        variant="info"
      >
        <font-awesome-icon :icon="['fas', 'eye']" /> publish
      </b-button>
      <b-button
        v-else-if="canPublish"
        @click="onUnpublish(newsEntry)"
        variant="warning"
      >
        <font-awesome-icon :icon="['fas', 'eye-slash']" /> unpublish
      </b-button>
      <b-button @click="onEdit(newsEntry)" variant="success">
        <font-awesome-icon :icon="['fas', 'pencil-alt']" />
      </b-button>
      <b-button
        @click="onDelete(newsEntry)"
        v-if="!newsEntry.published && canDelete"
        variant="danger"
      >
        <font-awesome-icon :icon="['fas', 'trash']" />
      </b-button>
    </div>
  </div>
</template>

<script>
import DateTimeFormatMixin from '~/components/mixins/DateTimeFormatMixin';
import AuthorizedMixin from '~/components/security/AuthorizedMixin';

export default {
  mixins: [DateTimeFormatMixin, AuthorizedMixin],
  props: {
    newsEntry: {
      type: Object,
      default: null,
    },
    languages: {
      type: Array,
      default: () => {
        return [];
      },
    },
    fallbackLanguage: {
      type: String,
      default: 'en',
    },
  },
  computed: {
    canPublish() {
      return this.isAuthorized(['NEWS_PUBLISH']);
    },
    canDelete() {
      return this.isAuthorized(['NEWS_DELETE']);
    },
    _hasFallbackLang() {
      return (
        this.newsEntry.title &&
        this._notEmpty(this.newsEntry.title[this.fallbackLanguage])
      );
    },
    _hasImageOrVideo() {
      return this.newsEntry.imageId && this.newsEntry.imageId > 0;
    },
    isPublishable() {
      return (
        this.newsEntry &&
        this.newsEntry.title &&
        this._hasFallbackLang &&
        this._notEmpty(this.newsEntry.dateDisplay) &&
        this._notEmpty(this.newsEntry.linkTo) &&
        this._hasImageOrVideo
      );
    },
    baseUrl() {
      return process.env.baseURL;
    },
  },
  methods: {
    _notEmpty(what) {
      return what && what !== '';
    },
    onEdit() {
      this.$emit('edit-entry', this.newsEntry);
    },
    onDelete() {
      this.$emit('delete-entry', this.newsEntry);
    },
    onPublish() {
      this.$emit('publish-entry', this.newsEntry);
    },
    onUnpublish() {
      this.$emit('unpublish-entry', this.newsEntry);
    },
  },
};
</script>
